<?php

/*
Addon: Blog Posts Style3
*/

class VCBLOGANDNEWS_Blog_Posts_Style3 {

	/*
	 * Contruct
	 */
    public function __construct() {

        add_action('wp_enqueue_scripts', array($this, 'load_scripts'));

        add_shortcode('vcblogandnews_blog_posts_style3', array($this, 'shortcode_addon_func'));

        add_action('init', array($this, 'map_vc_addon'));

    }

    function load_scripts() {
		
		wp_enqueue_style( 'vcblogandnews-bootstrap' );
        wp_enqueue_style( 'vcblogandnews-style' );
        wp_enqueue_style( 'vcblogandnews-style-blog' );
		wp_enqueue_style( 'font-awesome' );
		wp_enqueue_style( 'vcblogandnews-animations' );
		wp_enqueue_script( 'vcblogandnews-appear' );
		wp_enqueue_script( 'vcblogandnews-js-animations' );
		
    }
	
	/*
	 * Addon View
	 */
    public function shortcode_addon_func($atts, $content = null, $tag) {
		static $instance;
		$instance++;

        extract(shortcode_atts(array(

            'name' 					=> '',
            'columns' 				=> '1',
			
			// Query
			'source' 				=> 'post',
			'posts_source' 			=> 'all_posts',
			'posts_type' 			=> '',
			'categories' 			=> '',									
			'categories_post_type' 	=> '',
			'pagination' 			=> 'off',
			'pagination_type' 		=> 'numeric',
			'num_posts_page' 		=> '',
			'num_posts' 			=> '', 	
			'orderby' 				=> 'date',
			'order' 				=> 'DESC',
						
			// Style
            'custom_style' 			=> 'off',
            'title_color' 			=> '#333333',
            'text_color' 			=> '#747474',
            'date_color' 			=> '#AAAAAA',
            'category_color' 		=> '#FFFFFF',
            'bg_category_color' 	=> '#000000',
            'link_color' 			=> '#c9564c',
            'link_h_color' 			=> '#e7685d',
			

			// Animations
			'addon_animate'			=> 'off',
			'effect'				=> 'fade-in',
			'delay'					=> '0',
			

        ), $atts));
		
		$container_class = $class_load_more = $class_item_load_more = $css_title = $css_text = $css_link = $css_date = $css_bg_comment = $css_comment = $css_comment_link = $js_class = $data_value = $css_current_pag_num = '';
		$css_bg_comment = 'style="--bg-comment-color-var:#009688;"';
		if($columns == '1') : $columns_class = 'col-xs-12'; $container_class = 'vcblogandnews-bp-vc-blogs-1-col'; endif;
		if($columns == '2') : $columns_class = 'col-xs-6'; $container_class = 'vcblogandnews-bp-vc-blogs-2-col'; endif;
		if($columns == '3') : $columns_class = 'col-xs-4'; $container_class = 'vcblogandnews-bp-vc-blogs-3-col'; endif;		
		if(empty($num_posts)) : $num_posts = 6; endif;		
		
		$post_id = get_the_id(); 
		// PAGINATION		
		if($pagination == 'yes') {
			if ( get_query_var('paged') ) {
				$paged = get_query_var('paged');				
			} elseif ( get_query_var('page') ) {			
				$paged = get_query_var('page');			
			} else {			
				$paged = 1;			
			}
		}
		// #PAGINATION		
		
		// Load More
		if($pagination == 'load-more') : 
			$class_load_more = 'vcblogandnews-bp-load-more-style3'; 
			$class_item_load_more = 'vcblogandnews-bp-item-load-more-style3';
		endif;
		// #Load More
		
		// LOOP QUERY
		$query = vcblogandnews_query( $source,
							$posts_source, 
							$posts_type, 
							$categories,
							$categories_post_type, 
							$order, 
							$orderby, 
							$pagination, 
							$pagination_type,
							$num_posts, 
							$num_posts_page );	
		
		if($custom_style == 'on') :
			$css_title = 'style="color:'.$title_color.'" onMouseOver="this.style.color = \''.$link_h_color.'\';" onMouseLeave="this.style.color = \''.$title_color.'\';"';
			$css_text = 'style="color:'.$text_color.'"';
			$css_date = 'style="color:'.$date_color.'"';			
			$css_bg_category_link = 'style="color:'.$category_color.';background:'.$bg_category_color.'" onMouseOver="this.style.color = \''.$bg_category_color.'\';this.style.backgroundColor = \''.$category_color.'\';" onMouseLeave="this.style.color = \''.$category_color.'\';this.style.backgroundColor = \''.$bg_category_color.'\';"';			
			$css_link = 'style="color:'.$link_color.'" onMouseOver="this.style.color = \''.$link_h_color.'\';" onMouseLeave="this.style.color = \''.$link_color.'\';"';			
			$css_current_pag_num = 'style="color:'.$link_h_color.'"';
		endif;

		$return .= '<div class="vcblogandnews-clear"></div>';
		
		$count = 0;
		
		$return .= '<div class="vcblogandnews vcblogandnews-bp-vc-element-blogs '.$class_load_more.' vcblogandnews-bp-blogs-style3 '.$container_class.' vcblogandnews-bp-vc-element-blogs-'.$instance.' element-no-padding">';
		
		if($style == ''): $style = ''; endif;
		
		$return .= '<div class="vcblogandnews-bp-vc-element-blogs-article-container">';
		
		// Start Query Loop
		$loop = new WP_Query($query);		

		// Load More
		if($pagination == 'load-more') : 
		
			$readtext 		= esc_html__('Read More','vcblogandnews');
			$loading 		= esc_html__('Loading posts...','vcblogandnews');
			$nomoreposts 	= esc_html__('No more posts to load.','vcblogandnews');		
		
			wp_enqueue_script(
				'vcblogandnews-bp-load-blogs-style3',
				VCBLOGANDNEWS_URL . 'assets/js/vcblogandnews-bp-load-more-style3.js',
				array('jquery'),
				'1.0',
				true
			);		
					
			$max = $loop->max_num_pages;
			$paged = ( get_query_var('paged') > 1 ) ? get_query_var('paged') : 1;
			
			// Add some parameters for the JS.
			wp_localize_script(
				'vcblogandnews-bp-load-blogs-style3',
				'fnwp_',
				array(
					'startPage' 	=> $paged,
					'maxPages' 		=> $max,
					'nextLink' 		=> next_posts($max, false),
					'readtext'		=> $readtext,
					'loading'		=> $loading,
					'nomoreposts'	=> $nomoreposts,
					'cssLink'		=> $css_link
				)
			);
		endif;
		// #Load More


		
		if($loop) :
			while ( $loop->have_posts() ) : $loop->the_post();
		
				$id_post = get_the_id();
				$link = get_permalink(); 
				if($count & 1) : $class_odd = "vc-element-post-even"; else : $class_odd = "vc-element-post-odd"; endif;		

				$return .= '<article class="item-blogs first-element-blogs '.$columns_class.' '.$class_item_load_more.' '.$class_odd.vcblogandnews_animate_class($addon_animate,$effect,$delay).'>';;

					$return .= '<div class="article-image col-xs-6">';
						$return .= vcblogandnews_get_thumb('vcblogandnews-large');
						$return .= vcblogandnews_check_post_format();
						$return .= '<div class="article-category">'.vcblogandnews_get_category($source,$post_type,$css_bg_category_link).'</div>';
					$return .= '</div>';					
					
					$return .= '<div class="article-info col-xs-6">';
						$return .= '<h3 class="article-title"><a href="'.$link.'" '.$css_title.'>'.get_the_title().'</a></h3>';								
						$return .= '<div class="article-info-top">';								
							$return .= '<div class="article-author">'.vcblogandnews_get_author($css_link).'</div>';
							$return .= '<div class="article-separator">-</div>';
							$return .= '<div class="article-date" '.$css_date.'>'.get_the_date().'</div>';
						$return .= '</div>';																	
						$return .= '<div class="article-info-bottom">';
							$return .= '<p class="article-excerpt" '.$css_text.'>' . vcblogandnews_get_blogs_excerpt(300,'off') . '</p>';
							$return .= '<div class="worldblog-clear"></div>';										
						$return .= '</div>';
						$return .= vcblogandnews_post_social_share($css_link);
					$return .= '</div>';
						
				$return .= '</article>';				
				
				$count_clear = $count + 1;
				if(($count_clear % $columns) == 0) : $return .= '<div class="vcblogandnews-clear"></div>'; endif;
			
			$count++;
			endwhile;
		endif;	
		
		$return .= '</div><div class="vcblogandnews-clear"></div>';
		
		/**********************************************************************/
		/****************************** PAGINATION ****************************/
		/**********************************************************************/ 
		if($pagination == 'yes') {
				$return .= '<div class="vcblogandnews-clear"></div><div class="vcblogandnews-bp-blogs-display-'.$instance.' vcblogandnews-bp-vc-pagination">';
				if($pagination_type == 'numeric') {
					$return .= vcblogandnews_posts_numeric_pagination($pages = '', $range = 2,$loop,$paged,$css_current_pag_num,$css_link);
				} else {
					$return .= '<div class="vcblogandnews-bp-pagination-normal">';
						$return .= get_next_posts_link( '<span '.$css_link.'>Older blogs</span>', $loop->max_num_pages );
						$return .= get_previous_posts_link( '<span '.$css_link.'>Newer blogs</span>' );
					$return .= '</div>';
				}
				$return .= '<div class="vcblogandnews-clear"></div></div>';
		}
		/**********************************************************************/
		/***************************** #PAGINATION ****************************/
		/**********************************************************************/ 
		
		$return .= '</div>';
		wp_reset_query();
		return $return;
    }	

	
	/*
	 * Addon Backend
	 */	
    function map_vc_addon() {
        if (function_exists("vc_map")) {

            vc_map(array(
                "name" => esc_html__("Blog Posts Style 3", "vcblogandnews"),
                "base" => "vcblogandnews_blog_posts_style3",
                "content_element" => true,
                "show_settings_on_create" => true,
                "category" => esc_html__("Blog and News", "vcblogandnews"),
                'description' => esc_html__('add your posts', 'vcblogandnews'),
                "icon" => VCBLOGANDNEWS_URL . '/assets/img/vc-blog-posts-style.png',
                "params" => array(
					array(
							"type" => "textfield",
							"class" => "",
							"heading" => esc_html__("Blogs Display Name",'vcblogandnews'),
							"param_name" => "name",
							"admin_label" => true,				  				  			  				  
					),
					
					// QUERY
					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Source", 'vcblogandnews'),
					  "param_name" => "source",
					  "value" => array(
										esc_html__('Wordpress Posts','vcblogandnews') 		=> 'post',
										esc_html__('Custom Posts Type','vcblogandnews')  	=> 'post_type',
					   ),
					   "group" => "Query"				   			   
					),

					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("All Posts/Sticky Posts", 'vcblogandnews'),
					  "param_name" => "blogs_source",
					  "value" => array(
										esc_html__('All Posts','vcblogandnews') 		 		=> 'all_posts',
										esc_html__('Only Sticky Posts','vcblogandnews')  	=> 'sticky_posts',
					   ),
					   "group" => "Query",
					  "dependency" => array(
								'element' => 'source',
								'value' => array( 'post' )
					  ),					   				   			   
					),

					array(
					  "type" => "posttypes", 
					  "class" => "",
					  "heading" => esc_html__("Select Post Type Source",'vcblogandnews'),
					  "param_name" => "posts_type",
					  "group" => "Query",
					  "dependency" => array(
								'element' => 'source',
								'value' => array( 'post_type' )
					  ),					  				  					  				  			  				  
					),
					array(
					  "type" => "checkbox", 
					  "class" => "",
					  "heading" => esc_html__("Categories",'vcblogandnews'),
					  "param_name" => "categories",
					  "group" => "Query", 
					  "value" => vcblogandnews_get_category_array(),	  
					  "dependency" => array(
								'element' => 'source',
								'value' => array( 'post' )
					  ),				  					  				  					  				  			  				  
					),				
					
					
					array(
					  "type" => "textfield", 
					  "class" => "",
					  "heading" => esc_html__("Categories Post Type",'vcblogandnews'),
					  "param_name" => "categories_post_type",
					  "description" => esc_html__("Write Categories slug separate by comma(,) for example: cat-slug1, cat-slug2, cat-slug3 (Leave empty for all categories)","vcblogandnews"),
					  "group" => "Query",
					  "dependency" => array(
								'element' => 'source',
								'value' => array( 'post_type' )
					  ),				  					  				  					  				  			  				  
					),

					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Order", 'vcblogandnews'),
					  "param_name" => "order",
					  "value" => array(
										esc_html__('DESC','vcblogandnews')  	=> 'DESC',
										esc_html__('ASC','vcblogandnews') 	=> 'ASC'
										
					   ),
					   "group" => "Query"				   			   
					),

					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Order By", 'vcblogandnews'),
					  "param_name" => "orderby",
					  "value" => array(
										esc_html__('Date','vcblogandnews') 				=> 'date',
										esc_html__('ID','vcblogandnews')  				=> 'ID',
										esc_html__('Author','vcblogandnews') 			=> 'author',
										esc_html__('Title','vcblogandnews')  			=> 'title',
										esc_html__('Name','vcblogandnews') 				=> 'name',
										esc_html__('Modified','vcblogandnews')  			=> 'modified',
										esc_html__('Parent','vcblogandnews') 			=> 'parent',
										esc_html__('Rand','vcblogandnews')  				=> 'rand',
										esc_html__('Comments Count','vcblogandnews')  	=> 'comment_count',
										esc_html__('Views','vcblogandnews')				=> 'views',
										esc_html__('None','vcblogandnews')  				=> 'none',																																													
					   ),
					   "group" => "Query"				   			   
					),												

					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Pagination", 'vcblogandnews'),
					  "param_name" => "pagination",
					  "value" => array(
										esc_html__('No','vcblogandnews')  						=> 'no',
										esc_html__('Yes','vcblogandnews') 						=> 'yes',
										esc_html__('Yes with load more','vcblogandnews') 		=> 'load-more'
										
					   ),				   
					  "group" => "Query"				   			   
					),

					array(
					  "type" => "textfield", 
					  "class" => "",
					  "heading" => esc_html__("Number Posts",'vcblogandnews'),
					  "param_name" => "num_posts",
					  "description" => "ex 10",
					  "group" => "Query",
					  "dependency" => array(
								'element' => 'pagination',
								'value' => array( 'no' )
					  ),					  				  					  				  			  				  
					),

					array(
					  "type" => "dropdown",
					  "class" => "",
					  "heading" => esc_html__("Pagination Type", 'vcblogandnews'),
					  "param_name" => "pagination_type",
					  "value" => array(
										esc_html__('Numeric','vcblogandnews') 		=> 'numeric',
										esc_html__('Normal','vcblogandnews')  		=> 'normal',
					  ),
					  "group" => "Query",
					  "dependency" => array(
								'element' => 'pagination',
								'value' => array( 'yes' )
					  ),				   				   			   
					),

					array(
					  "type" => "textfield", 
					  "class" => "",
					  "heading" => esc_html__("Number Posts For Page",'vcblogandnews'),
					  "param_name" => "num_posts_page",
					  "description" => "ex 10",
					  "group" => "Query",
					  "dependency" => array(
								'element' => 'pagination',
								'value' => array( 'yes','load-more' )
					  ),					  				  					  				  			  				  
					),				
					
					// STYLE					
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Style", 'vcblogandnews'),
						"param_name" => "custom_style",
						"value" => array(
										esc_html__('Off','vcblogandnews') 	=> 'off',
										esc_html__('On','vcblogandnews') 	=> 'on'
										
						),
						"group" => "Style"
					),				
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Title Color", 'vcblogandnews'),
						"param_name" => "title_color",
						"value" => '#333333',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Text Color", 'vcblogandnews'),
						"param_name" => "text_color",
						"value" => '#747474',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Date Color", 'vcblogandnews'),
						"param_name" => "date_color",
						"value" => '#AAAAAA',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Category Color", 'vcblogandnews'),
						"param_name" => "category_color",
						"value" => '#FFFFFF',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Category Background Color", 'vcblogandnews'),
						"param_name" => "bg_category_color",
						"value" => '#000000',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),					
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Link Color", 'vcblogandnews'),
						"param_name" => "link_color",
						"value" => '#c9564c',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),
					array(
						"type" => "colorpicker",
						"class" => "",
						"heading" => esc_html__("Link Hover Color", 'vcblogandnews'),
						"param_name" => "link_h_color",
						"value" => '#e7685d',
						'dependency' => array(
								'element' => 'custom_style',
								'value' => array( 'on' )
						),
						"group" => "Style"				  
					),														
					// ANIMATION								  							  		  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate", 'vcblogandnews'),
						"param_name" => "addon_animate",
						"value" => array(
										esc_html__('Off','vcblogandnews') 	=> 'off',
										esc_html__('On','vcblogandnews') 	=> 'on'
										
						),
						"dependency" => array(
							"element" => "pagination",
							"value" => array( "no", "yes" )
						),						
						"group" => "Animation"
					),			  
					array(
						"type" => "dropdown",
						"class" => "",
						"heading" => esc_html__("Animate Effects", 'vcblogandnews'),
						"param_name" => "effect",
						"value" => vcblogandnews_animation_effect(),
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"group" => "Animation"				   
					),				  
					array(
						"type" => "textfield",
						"class" => "",
						"heading" => esc_html__("Animate Delay (ms)",'vcblogandnews'),
						"param_name" => "delay",
						"description" => "ex 1000",					  
						"dependency" => array(
							"element" => "addon_animate",
							"value" => array( "on" )
						),
						"value" => "0",
						"group" => "Animation"					  
					),
                ),
            ));


        }
    }

} // End Class

if (class_exists('WPBakeryShortCode')) {
    class WPBakeryShortCode_VCBLOGANDNEWS_Blog_Posts_Style3 extends WPBakeryShortCode {
    }
}

// Initialize Element Class
if (class_exists('VCBLOGANDNEWS_Blog_Posts_Style3')) {
    new VCBLOGANDNEWS_Blog_Posts_Style3();
}

