<?php

if (!class_exists('Vcblogandnews_Main')) :

    /**
     * Main Vcblogandnews_Main Class
     *
     */	 
	class Vcblogandnews_Main {

		private static $instance;	
		
        public static function instance() {
            if (!isset(self::$instance) && !(self::$instance instanceof Vcblogandnews_Main)) {

                self::$instance = new Vcblogandnews_Main;

                add_action('plugins_loaded', array(self::$instance, 'load_plugin_textdomain'));

                add_action('plugins_loaded', array(self::$instance, 'includes_files'));

                add_action('plugins_loaded', array(self::$instance, 'include_addons'));

				add_action('wp_enqueue_scripts', array(self::$instance, 'load_general_scripts'));

            }
            return self::$instance;
        }

        /**
         * Load Plugin Text Domain
         */
        public function load_plugin_textdomain() {
			$path = dirname(plugin_basename( __FILE__ )) . '/languages/';
			$loaded = load_plugin_textdomain( 'vcblogandnews', false, $path);
        }		
		
		
        /**
         * Include required files
         *
         */
        public function includes_files() {

            /* Load VC Field Types */
            include_once( plugin_dir_path( __FILE__ ) . 'includes/vcblogandnews_functions.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'includes/vcblogandnews_helper.php' );
			
        }		

        /**
         * Include VC Addons
         *
         */
        public function include_addons() {

			include_once( plugin_dir_path( __FILE__ ) . 'addons/blog/class-vcblogandnews-blog-posts-style1.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/blog/class-vcblogandnews-blog-posts-style2.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/blog/class-vcblogandnews-blog-posts-style3.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/blog/class-vcblogandnews-blog-posts-style4.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/blog/class-vcblogandnews-blog-posts-style5.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/blog/class-vcblogandnews-blog-posts-style6.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news/class-vcblogandnews-news-posts-style1.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news/class-vcblogandnews-news-posts-style2.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news/class-vcblogandnews-news-posts-style3.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news/class-vcblogandnews-news-posts-style4.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news/class-vcblogandnews-news-posts-style5.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news/class-vcblogandnews-news-posts-style6.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news_v2/class-vcblogandnews-news-v2-posts-style1.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news_v2/class-vcblogandnews-news-v2-posts-style2.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news_v2/class-vcblogandnews-news-v2-posts-style3.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news_v2/class-vcblogandnews-news-v2-posts-style4.php' );
			include_once( plugin_dir_path( __FILE__ ) . 'addons/news_v2/class-vcblogandnews-news-v2-posts-style5.php' );
			
        }

        /**
         * Load general scripts
         */
        public function load_general_scripts() {

			if (!class_exists('Mulse_Main')) {
				wp_enqueue_style( 'vcblogandnews-fonts',  plugin_dir_url( __FILE__ ) . 'assets/css/fonts.css' );
			}
			
			wp_register_style( 'vcblogandnews-bootstrap',  plugin_dir_url( __FILE__ ) . 'assets/css/bootstrap.css' );
			wp_register_style( 'vcblogandnews-style',  plugin_dir_url( __FILE__ ) . 'assets/css/style.css' );
			wp_register_style( 'vcblogandnews-style-blog',  plugin_dir_url( __FILE__ ) . 'assets/css/style_blog.css' );
			wp_register_style( 'vcblogandnews-style-news',  plugin_dir_url( __FILE__ ) . 'assets/css/style_news.css' );
			wp_register_style( 'vcblogandnews-style-news-v2',  plugin_dir_url( __FILE__ ) . 'assets/css/style_news_v2.css' );
			wp_register_style( 'vcblogandnews-animations',  plugin_dir_url( __FILE__ ) . 'assets/css/animations.min.css' );
			wp_enqueue_script( 'jquery');
			wp_register_script( 'vcblogandnews-appear',  plugin_dir_url( __FILE__ ) . 'assets/js/appear.min.js' );
			wp_register_script( 'vcblogandnews-js-animations',  plugin_dir_url( __FILE__ ) . 'assets/js/animations.min.js' );			
			wp_enqueue_script( 'vcblogandnews-js',  plugin_dir_url( __FILE__ ) . 'assets/js/vcblogandnews.js' );			
						
        }			

	}
	
	
endif; // End if class_exists check

function VCBLOGANDNEWS() {
    return Vcblogandnews_Main::instance();
}

// Get VCBLOGANDNEWS Running
VCBLOGANDNEWS();